Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkProperty Class Reference

`#include <vtkProperty.h>`

Inheritance diagram for vtkProperty:

[legend]
Collaboration diagram for vtkProperty:

[legend]
List of all members.

## Detailed Description

represent surface properties of a geometric object

Date:
  2003/01/06 20:36:14

Revision:
  1.60

vtkProperty is an object that represents lighting and other surface properties of a geometric object. The primary properties that can be set are colors (overall, ambient, diffuse, specular, and edge color); specular power; opacity of the object; the representation of the object (points, wireframe, or surface); and the shading method to be used (flat, Gouraud, and Phong). Also, some special graphics features like backface properties can be set and manipulated with this object.

See also:
  vtkActor vtkPropertyDevice

Created by:
  - Martin, Ken

CVS contributions (if > 5%):
  - Martin, Ken (46%)
  - Schroeder, Will (37%)
  - Lorensen, Bill (6%)

CVS logs (CVSweb):
  - .`h` (`/Rendering/vtkProperty.h)`
  - .`cxx` (`/Rendering/vtkProperty.cxx)`

Examples:
  vtkProperty (Examples)

Tests:
  vtkProperty (Tests)

Definition at line 70 of file vtkProperty.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | DeepCopy (vtkProperty *p)
virtual void | Render (vtkActor *, vtkRenderer *)
virtual void | BackfaceRender (vtkActor *, vtkRenderer *)
virtual void | SetInterpolation (int)
virtual int | GetInterpolation ()
void | SetInterpolationToFlat ()
void | SetInterpolationToGouraud ()
void | SetInterpolationToPhong ()
char * | GetInterpolationAsString ()
virtual void | SetRepresentation (int)
virtual int | GetRepresentation ()
void | SetRepresentationToPoints ()
void | SetRepresentationToWireframe ()
void | SetRepresentationToSurface ()
char * | GetRepresentationAsString ()
void | SetColor (float r, float g, float b)
void | SetColor (float a[3])
float * | GetColor ()
void | GetColor (float rgb[3])
virtual void | SetAmbient (float)
virtual float | GetAmbient ()
virtual void | SetDiffuse (float)
virtual float | GetDiffuse ()
virtual void | SetSpecular (float)
virtual float | GetSpecular ()
virtual void | SetSpecularPower (float)
virtual float | GetSpecularPower ()
virtual void | SetOpacity (float)
virtual float | GetOpacity ()
virtual void | SetAmbientColor (float, float, float)
virtual void | SetAmbientColor (float[3])
virtual float * | GetAmbientColor ()
virtual void | GetAmbientColor (float data[3])
virtual void | SetDiffuseColor (float, float, float)
virtual void | SetDiffuseColor (float[3])
virtual float * | GetDiffuseColor ()
virtual void | GetDiffuseColor (float data[3])
virtual void | SetSpecularColor (float, float, float)
virtual void | SetSpecularColor (float[3])
virtual float * | GetSpecularColor ()
virtual void | GetSpecularColor (float data[3])
virtual int | GetEdgeVisibility ()
virtual void | SetEdgeVisibility (int)
virtual void | EdgeVisibilityOn ()
virtual void | EdgeVisibilityOff ()
virtual void | SetEdgeColor (float, float, float)
virtual void | SetEdgeColor (float[3])
virtual float * | GetEdgeColor ()
virtual void | GetEdgeColor (float data[3])
virtual void | SetLineWidth (float)
virtual float | GetLineWidth ()
virtual void | SetLineStipplePattern (int)
virtual int | GetLineStipplePattern ()
virtual void | SetLineStippleRepeatFactor (int)
virtual int | GetLineStippleRepeatFactor ()
virtual void | SetPointSize (float)
virtual float | GetPointSize ()
virtual int | GetBackfaceCulling ()
virtual void | SetBackfaceCulling (int)
virtual void | BackfaceCullingOn ()
virtual void | BackfaceCullingOff ()
virtual int | GetFrontfaceCulling ()
virtual void | SetFrontfaceCulling (int)
virtual void | FrontfaceCullingOn ()
virtual void | FrontfaceCullingOff ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkProperty * | SafeDownCast (vtkObject *o)
vtkProperty * | New ()
## Protected Methods
| vtkProperty ()
| ~vtkProperty ()
## Protected Attributes
float | Color [3]
float | AmbientColor [3]
float | DiffuseColor [3]
float | SpecularColor [3]
float | EdgeColor [3]
float | Ambient
float | Diffuse
float | Specular
float | SpecularPower
float | Opacity
float | PointSize
float | LineWidth
int | LineStipplePattern
int | LineStippleRepeatFactor
int | Interpolation
int | Representation
int | EdgeVisibility
int | BackfaceCulling
int | FrontfaceCulling

## Member Typedef Documentation

typedef vtkObject vtkProperty::Superclass

| Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty. Definition at line 73 of file vtkProperty.h.

## Constructor & Destructor Documentation

vtkProperty::vtkProperty | ( |  | ) | `[protected]`

vtkProperty::~vtkProperty | ( |  | ) | `[inline, protected]`

| Definition at line 248 of file vtkProperty.h.

## Member Function Documentation

virtual const char* vtkProperty::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty.

int vtkProperty::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty.

virtual int vtkProperty::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty.

vtkProperty* vtkProperty::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty.

void vtkProperty::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty.

vtkProperty* vtkProperty::New | ( |  | ) | `[static]`

| Construct object with object color, ambient color, diffuse color, specular color, and edge color white; ambient coefficient=0; diffuse coefficient=0; specular coefficient=0; specular power=1; Gouraud shading; and surface representation. Backface and frontface culling are off. Reimplemented from vtkObject. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty.

void vtkProperty::DeepCopy | ( | vtkProperty * | p | ) |

| Assign one property to another.

virtual void vtkProperty::Render | ( | vtkActor * | ,
|  | vtkRenderer * |
| ) | `[inline, virtual]`

| This method causes the property to set up whatever is required for its instance variables. This is actually handled by a subclass of vtkProperty, which is created automatically. This method includes the invoking actor as an argument which can be used by property devices that require the actor. Reimplemented in vtkRIBProperty, vtkMesaProperty, and vtkOpenGLProperty. Definition at line 91 of file vtkProperty.h.

virtual void vtkProperty::BackfaceRender | ( | vtkActor * | ,
|  | vtkRenderer * |
| ) | `[inline, virtual]`

| This method renders the property as a backface property. TwoSidedLighting must be turned off to see any backface properties. Note that only colors and opacity are used for backface properties. Other properties such as Representation, Culling are specified by the Property. Reimplemented in vtkMesaProperty, and vtkOpenGLProperty. Definition at line 98 of file vtkProperty.h.

virtual void vtkProperty::SetInterpolation | ( | int |  | ) | `[virtual]`

| Set the shading interpolation method for an object.

virtual int vtkProperty::GetInterpolation | ( |  | ) | `[virtual]`

| Set the shading interpolation method for an object.

void vtkProperty::SetInterpolationToFlat | ( |  | ) | `[inline]`

| Set the shading interpolation method for an object. Definition at line 104 of file vtkProperty.h. References VTK_FLAT.

void vtkProperty::SetInterpolationToGouraud | ( |  | ) | `[inline]`

| Set the shading interpolation method for an object. Definition at line 105 of file vtkProperty.h. References VTK_GOURAUD.

void vtkProperty::SetInterpolationToPhong | ( |  | ) | `[inline]`

| Set the shading interpolation method for an object. Definition at line 106 of file vtkProperty.h. References VTK_PHONG.

char * vtkProperty::GetInterpolationAsString | ( | void |  | ) | `[inline]`

| Return the method of shading as a descriptive character string. Definition at line 275 of file vtkProperty.h. References Interpolation, VTK_FLAT, and VTK_GOURAUD.

virtual void vtkProperty::SetRepresentation | ( | int |  | ) | `[virtual]`

| Control the surface geometry representation for the object.

virtual int vtkProperty::GetRepresentation | ( |  | ) | `[virtual]`

| Control the surface geometry representation for the object.

void vtkProperty::SetRepresentationToPoints | ( |  | ) | `[inline]`

| Control the surface geometry representation for the object. Definition at line 114 of file vtkProperty.h. References VTK_POINTS.

void vtkProperty::SetRepresentationToWireframe | ( |  | ) | `[inline]`

| Control the surface geometry representation for the object. Definition at line 115 of file vtkProperty.h. References VTK_WIREFRAME.

void vtkProperty::SetRepresentationToSurface | ( |  | ) | `[inline]`

| Control the surface geometry representation for the object. Definition at line 117 of file vtkProperty.h. References VTK_SURFACE.

char * vtkProperty::GetRepresentationAsString | ( | void |  | ) | `[inline]`

| Return the method of shading as a descriptive character string. Definition at line 293 of file vtkProperty.h. References Representation, VTK_POINTS, and VTK_WIREFRAME.

void vtkProperty::SetColor | ( | float | r,
|  | float | g,
|  | float | b
| ) |

| Set the color of the object. Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

void vtkProperty::SetColor | ( | float | a[3] | ) | `[inline]`

| Set the color of the object. Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method. Definition at line 126 of file vtkProperty.h.

float* vtkProperty::GetColor | ( |  | ) |

| Set the color of the object. Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

void vtkProperty::GetColor | ( | float | rgb[3] | ) |

| Set the color of the object. Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

virtual void vtkProperty::SetAmbient | ( | float |  | ) | `[virtual]`

| Set/Get the ambient lighting coefficient.

virtual float vtkProperty::GetAmbient | ( |  | ) | `[virtual]`

| Set/Get the ambient lighting coefficient.

virtual void vtkProperty::SetDiffuse | ( | float |  | ) | `[virtual]`

| Set/Get the diffuse lighting coefficient.

virtual float vtkProperty::GetDiffuse | ( |  | ) | `[virtual]`

| Set/Get the diffuse lighting coefficient.

virtual void vtkProperty::SetSpecular | ( | float |  | ) | `[virtual]`

| Set/Get the specular lighting coefficient.

virtual float vtkProperty::GetSpecular | ( |  | ) | `[virtual]`

| Set/Get the specular lighting coefficient.

virtual void vtkProperty::SetSpecularPower | ( | float |  | ) | `[virtual]`

| Set/Get the specular power.

virtual float vtkProperty::GetSpecularPower | ( |  | ) | `[virtual]`

| Set/Get the specular power.

virtual void vtkProperty::SetOpacity | ( | float |  | ) | `[virtual]`

| Set/Get the object's opacity. 1.0 is totally opaque and 0.0 is completely transparent.

virtual float vtkProperty::GetOpacity | ( |  | ) | `[virtual]`

| Set/Get the object's opacity. 1.0 is totally opaque and 0.0 is completely transparent.

virtual void vtkProperty::SetAmbientColor | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set/Get the ambient surface color. Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

virtual void vtkProperty::SetAmbientColor | ( | float | [3] | ) | `[virtual]`

| Set/Get the ambient surface color. Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

virtual float* vtkProperty::GetAmbientColor | ( |  | ) | `[virtual]`

| Set/Get the ambient surface color. Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

virtual void vtkProperty::GetAmbientColor | ( | float | data[3] | ) | `[virtual]`

| Set/Get the ambient surface color. Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

virtual void vtkProperty::SetDiffuseColor | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set/Get the diffuse surface color.

virtual void vtkProperty::SetDiffuseColor | ( | float | [3] | ) | `[virtual]`

| Set/Get the diffuse surface color.

virtual float* vtkProperty::GetDiffuseColor | ( |  | ) | `[virtual]`

| Set/Get the diffuse surface color.

virtual void vtkProperty::GetDiffuseColor | ( | float | data[3] | ) | `[virtual]`

| Set/Get the diffuse surface color.

virtual void vtkProperty::SetSpecularColor | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set/Get the specular surface color.

virtual void vtkProperty::SetSpecularColor | ( | float | [3] | ) | `[virtual]`

| Set/Get the specular surface color.

virtual float* vtkProperty::GetSpecularColor | ( |  | ) | `[virtual]`

| Set/Get the specular surface color.

virtual void vtkProperty::GetSpecularColor | ( | float | data[3] | ) | `[virtual]`

| Set/Get the specular surface color.

virtual int vtkProperty::GetEdgeVisibility | ( |  | ) | `[virtual]`

| Turn on/off the visibility of edges. On some renderers it is possible to render the edges of geometric primitives separately from the interior.

virtual void vtkProperty::SetEdgeVisibility | ( | int |  | ) | `[virtual]`

| Turn on/off the visibility of edges. On some renderers it is possible to render the edges of geometric primitives separately from the interior.

virtual void vtkProperty::EdgeVisibilityOn | ( |  | ) | `[virtual]`

| Turn on/off the visibility of edges. On some renderers it is possible to render the edges of geometric primitives separately from the interior.

virtual void vtkProperty::EdgeVisibilityOff | ( |  | ) | `[virtual]`

| Turn on/off the visibility of edges. On some renderers it is possible to render the edges of geometric primitives separately from the interior.

virtual void vtkProperty::SetEdgeColor | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set/Get the color of primitive edges (if edge visibility is enabled).

virtual void vtkProperty::SetEdgeColor | ( | float | [3] | ) | `[virtual]`

| Set/Get the color of primitive edges (if edge visibility is enabled).

virtual float* vtkProperty::GetEdgeColor | ( |  | ) | `[virtual]`

| Set/Get the color of primitive edges (if edge visibility is enabled).

virtual void vtkProperty::GetEdgeColor | ( | float | data[3] | ) | `[virtual]`

| Set/Get the color of primitive edges (if edge visibility is enabled).

virtual void vtkProperty::SetLineWidth | ( | float |  | ) | `[virtual]`

| Set/Get the width of a Line. The width is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

virtual float vtkProperty::GetLineWidth | ( |  | ) | `[virtual]`

| Set/Get the width of a Line. The width is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

virtual void vtkProperty::SetLineStipplePattern | ( | int |  | ) | `[virtual]`

| Set/Get the stippling pattern of a Line, as a 16-bit binary pattern (1 = pixel on, 0 = pixel off). This is only implemented for OpenGL. The default is 0xFFFF.

virtual int vtkProperty::GetLineStipplePattern | ( |  | ) | `[virtual]`

| Set/Get the stippling pattern of a Line, as a 16-bit binary pattern (1 = pixel on, 0 = pixel off). This is only implemented for OpenGL. The default is 0xFFFF.

virtual void vtkProperty::SetLineStippleRepeatFactor | ( | int |  | ) | `[virtual]`

| Set/Get the stippling repeat factor of a Line, which specifies how many times each bit in the pattern is to be repeated. This is only implemented for OpenGL. The default is 1.

virtual int vtkProperty::GetLineStippleRepeatFactor | ( |  | ) | `[virtual]`

| Set/Get the stippling repeat factor of a Line, which specifies how many times each bit in the pattern is to be repeated. This is only implemented for OpenGL. The default is 1.

virtual void vtkProperty::SetPointSize | ( | float |  | ) | `[virtual]`

| Set/Get the diameter of a point. The size is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

virtual float vtkProperty::GetPointSize | ( |  | ) | `[virtual]`

| Set/Get the diameter of a point. The size is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

virtual int vtkProperty::GetBackfaceCulling | ( |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If backface culling is on, polygons facing away from camera are not drawn.

virtual void vtkProperty::SetBackfaceCulling | ( | int |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If backface culling is on, polygons facing away from camera are not drawn.

virtual void vtkProperty::BackfaceCullingOn | ( |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If backface culling is on, polygons facing away from camera are not drawn.

virtual void vtkProperty::BackfaceCullingOff | ( |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If backface culling is on, polygons facing away from camera are not drawn.

virtual int vtkProperty::GetFrontfaceCulling | ( |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If frontface culling is on, polygons facing towards camera are not drawn.

virtual void vtkProperty::SetFrontfaceCulling | ( | int |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If frontface culling is on, polygons facing towards camera are not drawn.

virtual void vtkProperty::FrontfaceCullingOn | ( |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If frontface culling is on, polygons facing towards camera are not drawn.

virtual void vtkProperty::FrontfaceCullingOff | ( |  | ) | `[virtual]`

| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. If frontface culling is on, polygons facing towards camera are not drawn.

## Member Data Documentation

float vtkProperty::Color[3]`[protected]`

| Definition at line 250 of file vtkProperty.h.

float vtkProperty::AmbientColor[3]`[protected]`

| Definition at line 251 of file vtkProperty.h.

float vtkProperty::DiffuseColor[3]`[protected]`

| Definition at line 252 of file vtkProperty.h.

float vtkProperty::SpecularColor[3]`[protected]`

| Definition at line 253 of file vtkProperty.h.

float vtkProperty::EdgeColor[3]`[protected]`

| Definition at line 254 of file vtkProperty.h.

float vtkProperty::Ambient`[protected]`

| Definition at line 255 of file vtkProperty.h.

float vtkProperty::Diffuse`[protected]`

| Definition at line 256 of file vtkProperty.h.

float vtkProperty::Specular`[protected]`

| Definition at line 257 of file vtkProperty.h.

float vtkProperty::SpecularPower`[protected]`

| Definition at line 258 of file vtkProperty.h.

float vtkProperty::Opacity`[protected]`

| Definition at line 259 of file vtkProperty.h.

float vtkProperty::PointSize`[protected]`

| Definition at line 260 of file vtkProperty.h.

float vtkProperty::LineWidth`[protected]`

| Definition at line 261 of file vtkProperty.h.

int vtkProperty::LineStipplePattern`[protected]`

| Definition at line 262 of file vtkProperty.h.

int vtkProperty::LineStippleRepeatFactor`[protected]`

| Definition at line 263 of file vtkProperty.h.

int vtkProperty::Interpolation`[protected]`

| Definition at line 264 of file vtkProperty.h. Referenced by GetInterpolationAsString().

int vtkProperty::Representation`[protected]`

| Definition at line 265 of file vtkProperty.h. Referenced by GetRepresentationAsString().

int vtkProperty::EdgeVisibility`[protected]`

| Definition at line 266 of file vtkProperty.h.

int vtkProperty::BackfaceCulling`[protected]`

| Definition at line 267 of file vtkProperty.h.

int vtkProperty::FrontfaceCulling`[protected]`

| Definition at line 268 of file vtkProperty.h.

The documentation for this class was generated from the following file:

- Rendering/vtkProperty.h